/*	Routine Name	: SRIMAGE.C
	Programmer	: Rick Winkelspecht
	Date Written	: 9/18/90
	Whatsitdo		: This program will save and restore bit-images
				  to and from disk.
	How to Call	: To save a bit image --
				  save_image(x,y,xx,yy,file.ext)
				    Where x = left, y = top, xx = right, yy = bottom
				    file.ext - any valid DOS filename.

				  To read a bit image --
				  read_image(file.ext)
				    Where file.ext is an existing DOS filename.

*/

#include <graphics.h>
#include <stdio.h>

save_image(int left,int top,int right,int bottom,char *file)
{
     void *buffer;
     int size;
     FILE *image_out;
	if((image_out = fopen(file,"wb")) == NULL)   	/* Open file */
	  return(1);                                      /* Return 1 if nogood */
     size = imagesize(left,top,right,bottom);
     buffer = malloc(size);                            /* Allocate memory */
	if(buffer == NULL)                                /* Test to see if mem */
	  return(1);                                      /* allocated */
	getimage(left,top,right,bottom,buffer);           /* Read image into ram */
     fwrite(&size,2,1,image_out);                      /* write size of image */
     fwrite(buffer,size,1,image_out);                  /* write buffer */
     fclose(image_out);                                /* close file */
     free(buffer);                                     /* release ram */
     return(0);                                        /* return 0 -- OK!! */
}


read_image(char *file)
{
     void *buffer;
     int x,size;
     FILE *image_in;
     if((image_in = fopen(file,"rb")) == NULL)         /* Open file */
	  return(NULL);                                   /* Return 1 if nogood */
     fread(&size,2,1,image_in);                        /* Read size of image */
     buffer = malloc(size);                            /* Allocate Ram */
	if(buffer == NULL)                                /* Test to see if mem allocated */
	  return(NULL);                                   /* Return NULL if not */
	fread(buffer,size,1,image_in);                    /* read image */
     fclose(image_in);                                 /* close file */
     return(buffer);                                   /* return buffer address */
}
